// Algorithm 8.1.1   (Trial Division) 'Henri Cohen' 
//My implementation includes some changes. Ie P[k] is incremented after P[m]
//1(mod 8) require bound of 8. And repeating Factor code block
//Hopefully faithful to Algorithm as a View of this Algorithm with 
//if((P[k] - 1)/30)==(floor((P[k] - 1)/30) Modulo for P[1] -> P[8]
//leads to a Factorial view similar to the C++ Modulo PQa code blocks !
// Suitable for small factors only
//warren

#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include <iomanip> 
#include <set>
using namespace std;

typedef unsigned long long int Mi5;

template <typename NumberContainer>
void removeTheNumbers(NumberContainer& Primeans, Mi5 Pristart)
{
    for (auto iter{ Primeans.begin() }; iter != Primeans.end(); )
    {
        if (*iter < Pristart)
        {
            iter = Primeans.erase(iter);
        }
        else
        {
            ++iter;
        }
    }
}

vector<Mi5> Primer(Mi5 Tdamount) 
{
    Mi5 Pristart = 0;
    Mi5 n1 = Tdamount;
    vector<bool> prime(n1 + 1, true);

    prime[0] = false;
    prime[1] = false;
    int m1 = sqrt(n1);
    int NumberPrimes1 = 0;

    for (Mi5 p = 2; p <= m1; p++)
    {
        if (prime[p])
        {
            // Update all multiples of p
            for (Mi5 i = p * 2; i <= n1; i += p)
                prime[i] = false;
        }
    }
    // push all the primes into the vector 
    vector<Mi5> Primeans;
    for (int i = 0; i < n1; i++)
        if (prime[i]) {
            Primeans.push_back(i);
        }
    removeTheNumbers(Primeans, Pristart);
    for (auto ip : Primeans) {
        NumberPrimes1 += 1;
    }
    cout << "NumberPrimes1 =" << NumberPrimes1 << endl;
    return Primeans;
}


int main()
{
    int base[8] = { 1,7,11,13,17,19,23,29 };
    int Tal_2s[]{ 6,4,2,4,2,4,6,2 };
    vector<int> primes1;
    vector<int>newvacum;
    set<int>so;
    int len = sizeof(base) / sizeof(base[0]);  // Here 8
	int Step = 1;
	int Np = 0;
	int Tdamount = 0;
    int Bound1 = 0;
    int dFactor = 0;
	cout << "Enter Number to be Factored " << endl;
	cin >> Np ;
	cout << "Enter amount of Primes < 1 Million required for Trial Division Algorithm " << endl;
	cin >> Tdamount;
    vector<Mi5> Prians = Primer(Tdamount);
//    cout << "Enter a 'Bound' that is greater than Amount of Primes + 1" << endl;
//    cin >> Bound1;
    for (auto pip1 : Prians) {  //auto Bound Code Block !
        Bound1 += 1;
    }
    int KBound = Bound1;
    cout << "Your Bound is = " << KBound << endl;

    int StepT_i = -1;             //Tal_2s[] incrementer:Step 1.
    int MStepP = 0;              // Prians[] incrementer:Step 1.
    int Le = sqrt(Np);          //Sqrt rounds, ie sqrt(101) is 10:Step 1.
    int jIndex = 0;             //Index J
    int KPrime = 0;             //p[k]
    int r = 0;
    int numCounter1 = 0;
    int numFact1 = 0;
    int Np1 = 0;
    int Le1 = 0;
	do
	{
		if (Step == 1) {
            if (Np <= 5) {
                if (Np == 1) { cout << "Factor is 1" << endl;  dFactor = 1; }
                else if(Np == 2){ cout << "Factor is 2" << endl; dFactor = 2; }
                else if (Np == 3) { cout << "Factor is 3" << endl; dFactor = 3; }
                else if (Np == 4) { cout << "Factor is 2^2" << endl; dFactor = 2; }
                else if (Np == 5) { cout << "Factor is 5" << endl; dFactor = 5; }
                break;
            }
			Step = 2;
        }
		if (Step == 2) {
            MStepP += 1;
            if (MStepP > KPrime) {    //no p[k] yet         
                StepT_i = jIndex - 1;
                Step = 5;
            }
            dFactor = Prians[MStepP];
            KPrime += 1;
            numCounter1 = 0;
            Step = 3;
		}
		if (Step == 3) {                     //[Trial Divisor]
            do {
                r = Np % dFactor;
                if (r == 0) {
//                    cout << "Factor = " << dFactor << endl;
                    newvacum.push_back(dFactor);
                    numFact1 += 1;
                }
                if (numFact1 == 1) {
                    Np1 = (Np / dFactor);
                    Le1 = sqrt(Np);
                    r = Np % dFactor;
                    if (r == 0) {
                        if (dFactor == dFactor) {
//                            cout << "Factor = " << (dFactor * dFactor) << endl;
                            newvacum.push_back(dFactor);
                        }
                    }
                }
            } while (numFact1 < 1);
            Step = 4;
		}
		if (Step == 4) {
            if (dFactor > Le) {
                if (Np > 1) {
                    cout << "Remaining N is Prime " << endl;
                    for (int i = 0; i < newvacum.size(); i++) {
                        so.insert(newvacum[i]);
                    }
                    for(auto i = so.begin(); i != so.end(); i++){
                        cout << (*i) << endl;
                    }
                    break;
                }
            }
            if (StepT_i >= 8) {    //Check if < OK
                Step = 2;
                numCounter1 = 1;
            }
            if (numCounter1 == 0) {
                Step = 5;
            }
		}
		if (Step == 5) {
            StepT_i = StepT_i + (1 % 8);
            dFactor = Tal_2s[StepT_i];
            if (dFactor > KBound) {
                cout << " The remaining Prime Divisors are greater than Bound " << endl;
                for (int i = 0; i < newvacum.size(); i++) {
                    so.insert(newvacum[i]);
                }
                for (auto i = so.begin(); i != so.end(); i++) {
                    cout << (*i) << endl;
                }
                break;
            }
            Step -= 2;
		}
 
	} while (Step > 0 || Step < 5);
}
